//
//
void determineMinMaxStrengths( boolean global )
{
  float min_v, max_v;

  // give all the binding site types the same, global min and max
  if ( global )
  {
    min_v = Float.MAX_VALUE;
    max_v = Float.MIN_VALUE;

    for ( int i = 0; i < _regions.length; i++ )
    { 
      for ( int j = 0; j < _regions[i].numBindingSites(); j++ )
      {
        min_v = min( min_v, _regions[i].bindingSite(j).strength() );
        max_v = max( max_v, _regions[i].bindingSite(j).strength() );
      }
    }

    min_v = _global_min_v; 
    for ( int i = 0; i < _binding_site_types.length; i++ )
      _binding_site_types[i].minMaxStrength( min_v, max_v );
  }

  // store min and max on a per binding site type basis
  else
  {
    for ( int i = 0; i < _binding_site_types.length; i++ )
    {
      min_v = Float.MAX_VALUE;
      max_v = Float.MIN_VALUE;

      for ( int r = 0; r < _regions.length; r++ )
      { 
        for ( int j = 0; j < _regions[r].numBindingSites(); j++ )
        {
          if ( _regions[r].bindingSite(j).type() != i ) continue;

          min_v = min( min_v, _regions[r].bindingSite(j).strength() );
          max_v = max( max_v, _regions[r].bindingSite(j).strength() );
        }
      }
      min_v = _global_min_v;
      _binding_site_types[i].minMaxStrength( min_v, max_v );
    }
  }
}

void determineMaxRegionLength()
{
  long max_v = Long.MIN_VALUE;
  for ( int i = 0; i < _regions.length; i++ )
    if ( _regions[i].show() ) max_v = (long)max( max_v, _regions[i].len() );
  _regions_max_len = max_v;
}

int mouseXInRegionView()
{
  return mouseX-_region_view_origin[0];
}

int mouseYInRegionView()
{
  return mouseY-_region_view_origin[1];
}

