//
// COLORS
//
public final color BACKGROUND_COLOR = color( 255 );
public final color LABEL_COLOR = color( 100 )/*#1F78B4*/;
public final color DROP_DOWN_FILL_COLOR = color( 100 )/*#A6CEE3*/;
public final color DROP_DOWN_PRESSED_LINE_COLOR = #1F78B4;
public final color DROPBOX_FILL_COLOR = color( 255 );
public final color DROPBOX_LINE_COLOR = color( 100 )/*#1F78B4*/;
public final color DROPBOX_TEXT_COLOR = color( 100 )/*#1F78B4*/;
public final color SPATIAL_BOX_COLOR = color( 215 );

public final color REGION_VIEW_OUTLINE_COLOR = color( 220 );
public final color SCROLL_BAR_HIGHLIGHT_COLOR = color( 0 );

public final color REGION_LINE_COLOR = color( 100 );
public final color SCALE_BAR_COLOR = color( 100 );
public final color REGION_MAX_VALUE_LINE_COLOR = color( 235 );
public final color REGION_HALF_VALUE_LINE_COLOR = color( 255 );
public final color[] REGION_MAX_VALUE_BAND_COLORS = /*{ color(245), color(235) };*/ {color(235), color(235)};
public final color REGION_TAG_TEXT_COLOR = color( 100 );
public final color BINDING_SITE_OUTLINE_COLOR = REGION_MAX_VALUE_BAND_COLORS[0];
public final color BINDING_SITE_FILL_COLOR = color( 230 );
public final color ROLLED_OVER_BINDING_SITE_LINE_COLOR = color( 0 );
public final color ROLL_OVER_TEXT_BOX_COLOR = color( 255, 170 );
public final color ROLL_OVER_TEXT_BOX_TEXT_COLOR = color( ROLLED_OVER_BINDING_SITE_LINE_COLOR );
public final color FEATURE_LINE_COLOR = color( 175 );
public final color ROLLED_OVER_FEATURE_LINE_COLOR = color( ROLLED_OVER_BINDING_SITE_LINE_COLOR );

public final color ALIGNMENT_SELECTOR_LINE_COLOR = color( 100 );
public final color ALIGNMENT_SELECTOR_FILL_COLOR = color( 255 );
public final color ALIGNMENT_SELECTOR_SELECTED_FILL_COLOR = color( 220 );

public final color BINDING_SITE_LEGEND_LINE_COLOR = color( 200 );
public final color BINDING_SITE_LEGEND_TEXT_COLOR = color( 100 );
public final color BINDING_SITE_LEGEND_BOX_LINE_COLOR = color( 170 );

public final color[] SITE_COLOR = { #1F78B4,
                                    #33A02C,
                                    #E31A1C,
                                    #FF7F00,
                                    #6A3D9A,
                                    #A6CEE3,
                                    #B2DF8A,
                                    #FB9A99,
                                    #FDBF6F,
                                    #CAB2D6 };
public final color DEFAULT_COLOR = color( 210 );
public final color COLOR_PICKER_BUTTON_FILL_COLOR = color( 255 );
public final color COLOR_PICKER_BUTTON_SELECTED_FILL_COLOR = color( 220 );
public final color COLOR_PICKER_LINE_COLOR = color( 100 );
public final color COLOR_PICKER_BUTTON_TEXT_COLOR = color( 100 );
public final color COLOR_PICKER_SELECTED_LINE_COLOR = color( 0 );
public final color HIGHLIGHTED_COLOR = #E31A1C;

//
// SIZES
//
public static final int WINDOW_BORDER_WIDTH = 30;

public static final int DROP_DOWN_BOX_W = 8;
public static final int DROP_DOWN_BOX_OFFSET = 4;
public static final int DROPBOX_BORDER = 5;
public static final int DROPBOX_LINE_H = 8;
public static final int DROPBOX_LINE_OFFSET = 6;
public static final int DROPBOX_RADIO_BUTTON_W = 6;
public static final int DROPBOX_RADIO_BUTTON_OFFSET = 4;

public static final int REGION_HEIGHT = 40;
public static final int REGION_OFFSET = 10;
public static final int REGION_SCROLLBAR_OFFSET = 20;
public static final int REGION_SCROLLBAR_W = 8;
public static final int BINDING_SITE_MIN_WIDTH = 2;
public static final int BINDING_SITE_HEIGHT = 30;
public static final int FEATURE_HEIGHT = 8;
public static final int FEATURE_LINE_WEIGHT = 1;
public static final int REGION_TAG_OFFSET = 4;
public static final int REGION_LINE_WEIGHT = 1;
public static final int REGION_TAG_VERT_OFFSET = 6;
public static final int SCALE_BAR_LINE_WEIGHT = 1;
public static final int ROLLED_OVER_BINDING_SITE_LINE_WEIGHT = 1;
public static final int ROLLED_OVER_FEATURE_LINE_WEIGHT = 1;

public static final int SPATIAL_BOX_W = 20;
public static final int SPATIAL_BOX_H = 12;

public static final int SCALE_BAR_OFFSET = 15;
public static final int SCALE_BAR_H = 9;

public static final int ALIGNMENT_SELECTOR_BOX_W = 20;
public static final int ALIGNMENT_SELECTOR_OFFSET = 20;

public static final int BINDING_SITE_LEGEND_BOX_OFFSET = 5;
public static final int BINDING_SITE_LEGEND_BORDER_W = 10;
public static final int BINDING_SITE_LEGEND_BOX_W = 20;
public static final int BINDING_SITE_LEGEND_BOX_H = 10;
public static final int BINDING_SITE_LEGEND_TEXT_OFFSET = 16;
public static final int BINDING_SITE_LEGEND_OFFSET = 40;

public static final int LEGEND_COLOR_PICKER_OFFSET = 10;
public static final int COLOR_PICKER_BOX_W = 10;
public static final int COLOR_PICKER_BOX_OFFSET = 3;
public static final int COLOR_PICKER_BUTTON_OFFSET = 10;
public static final int CLEAR_BUTTON_H = 12;
public final int NUM_SITE_COLORS = SITE_COLOR.length;


//
// ENUMERATIONS
//
public static final int REGION_ALIGNMENT_LEFT = 0;
public static final int REGION_ALIGNMENT_CENTER = 1;
public static final int REGION_ALIGNMENT_RIGHT = 2;
public static final int REGION_ALIGNMENT_STRETCH = 3;


//
// GLOBAL (UNCHANGING) VARIABLES
//
public static Region[] _regions;
public static long _regions_max_len;
public static BindingSiteType[] _binding_site_types;
public static int[] _binding_site_order;

public static PFont _pixel_font_8;
public static PFont _pixel_font_8b;
public static PFont _verdana_font_12;
public static PFont _verdana_font_16;
public static PFont _verdana_font_30;

String _region_label, _type_label;

float _global_min_v = 0.0;
